<template>
    <section>
        <template v-if="loading || fail">
            <div class="text-center m-5 p-5">
                <span class="h2" v-if="loading"><i class="fas fa-spinner fa-spin"></i></span>
                <span class="h4" v-if="fail">
                    {{ fail.message }} <br>
                    <a href="#" class="btn btn-outline-primary mt-3" v-on:click.prevent="getUserInfo">Retry</a>
                </span>
            </div>
        </template>

        <template v-else>
            <h2>Profile</h2>

            <form>
                <div class="form-group">
                    <label for="nameInput">Name</label>
                    <input type="text" class="form-control" id="nameInput" v-bind:value="user.name" disabled>
                </div>

                <div class="form-group">
                    <label for="emailInput">Email address</label>
                    <input type="email" class="form-control" id="emailInput" aria-describedby="emailHelp" v-bind:value="user.email" disabled>
                </div>
            </form>

            <hr>

            <h3>Change Password</h3>

            <form>
                <div class="form-group">
                    <label for="oldPasswordInput">Old Password</label>
                    <input type="password" v-model="oldPassword" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.password}]" id="oldPasswordInput" placeholder="Password">

                    <template v-if="validationError && validationError.password">
                    <span class="invalid-feedback">
                        <strong>{{ validationError.password[0] }}</strong>
                    </span>
                    </template>
                </div>

                <div class="form-group">
                    <label for="newPasswordInput">New Password</label>
                    <input type="password" v-model="newPassword" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.new_password}]" id="newPasswordInput" placeholder="Password">

                    <template v-if="validationError && validationError.new_password">
                    <span class="invalid-feedback">
                        <strong>{{ validationError.new_password[0] }}</strong>
                    </span>
                    </template>
                </div>

                <div class="form-group">
                    <label for="passwordConfirmInput">Confirm Password</label>
                    <input type="password" class="form-control" id="passwordConfirmInput" v-model="newPasswordConfirmation" placeholder="Password">
                </div>

                <div class="alert alert-success" v-if="changePasswordSuccess">
                    {{ changePasswordSuccess.message }}
                    <button type="button" class="close" v-on:click.prevent="changePasswordSuccess = '';" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>

                <button type="submit" class="btn btn-primary" v-if="changePasswordLoading" disabled><i class="fas fa-spinner fa-spin"></i> CHANGE</button>
                <button type="submit" class="btn btn-primary" v-else v-on:click.prevent="changePassword">CHANGE</button>
            </form>
        </template>
    </section>
</template>

<script>
    export default {
        data: function () {
            return {
                // Inputs
                oldPassword: '',
                newPassword: '',
                newPasswordConfirmation: '',

                // User Profile
                user: '',

                // Fail flag
                fail: null,

                // Validation Error
                validationError: '',

                // Loading Flag
                changePasswordLoading: false,
                loading: false,

                // Change password
                changePasswordSuccess: '',
                changePasswordError: '',
            }
        },
        methods: {
            changePassword: function() {
                // Show loading
                this.changePasswordLoading = true;

                // Clear previous status and validation messages
                this.validationError = '';

                this.changePasswordSuccess = '';
                this.changePasswordError = '';

                // Make the request to the API
                axios.post('/api/change-password', { 'password': this.oldPassword, 'new_password': this.newPassword, 'new_password_confirmation': this.newPasswordConfirmation,})
                    .then(response => {
                        // Successfully Changed
                        this.changePasswordSuccess = {
                            'message': 'Password Successfully Changed.'
                        }

                        // Empty the inputs
                        this.oldPassword = '';
                        this.newPassword = '';
                        this.newPasswordConfirmation ='';
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 422) {
                                this.validationError = error.response.data.errors;
                            } else if (error.response.status === 401) {
                                this.validationError = {
                                    'password': ['Old password is incorrect.']
                                }
                            } else {
                                this.changePasswordError = {
                                    message: 'Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.changePasswordError = {
                                message: 'Something went wrong. Check your connection.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.changePasswordError = {
                                message: 'Something went wrong. Check your connection.'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.changePasswordLoading = false;
                    })
            },
            getUserInfo: function () {
                // Show the loading
                this.loading = true;

                // Clear previous status flags
                this.fail = null;

                // Make a request to the server
                axios.get('/api/user')
                    .then(response => {
                        this.user = response.data;
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 404) {
                                this.fail = {
                                    'message': 'Content Not Found'
                                };
                            } else if (error.response.status === 403 || error.response.status === 401) {
                                this.fail = {
                                    'message' : 'Looks like you\'re not authorized to access this content.'
                                };
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };
                        }
                    })
                    .then(e =>{
                        // Hide the loading
                        this.loading = false;
                    });
            }
        },
        mounted() {
            console.log('Admin - Profile mounted.');

            // Load user information
            this.getUserInfo();
        }
    }
</script>
